#ifndef DUNE_TECTONIC_TIMESTEPPING_HH
#define DUNE_TECTONIC_TIMESTEPPING_HH

#include <dune/common/bitsetvector.hh>

template <class VectorType, class MatrixType, class FunctionType, int dim>
class TimeSteppingScheme {
public:
  void virtual nextTimeStep() = 0;
  void virtual setup(VectorType const &ell, double _tau, double time,
                     VectorType &rhs, VectorType &iterate, MatrixType &AB) = 0;

  void virtual postProcess(VectorType const &iterate) = 0;
  void virtual extractDisplacement(VectorType &displacement) const = 0;
  void virtual extractVelocity(VectorType &velocity) const = 0;
};

#include "timestepping/newmark.hh"
#include "timestepping/backward_euler.hh"

#endif
