#ifndef DIM
#error DIM unset
#endif

#include <dune/common/fmatrix.hh>
#include <dune/common/function.hh>
#include <dune/common/fvector.hh>
#include <dune/istl/bcrsmatrix.hh>
#include <dune/istl/bvector.hh>

using SmallVector = Dune::FieldVector<double, DIM>;
using SmallMatrix = Dune::FieldMatrix<double, DIM, DIM>;
using MatrixType = Dune::BCRSMatrix<SmallMatrix>;
using VectorType = Dune::BlockVector<SmallVector>;
using FunctionType = Dune::VirtualFunction<double, double>;

template class Newmark<VectorType, MatrixType, FunctionType, DIM>;
template class BackwardEuler<VectorType, MatrixType, FunctionType, DIM>;
